
#include "Loc_ai\LAi_defines.c"
#include "Loc_ai\LAi_events.c"
#include "Loc_ai\LAi_utils.c"
#include "Loc_ai\LAi_login.c"
#include "Loc_ai\LAi_character.c"
#include "Loc_ai\LAi_templates.c"
#include "Loc_ai\LAi_types.c"
#include "Loc_ai\LAi_groups.c"
#include "Loc_ai\LAi_fightparams.c"
#include "Loc_ai\LAi_boarding.c"
#include "Loc_ai\LAi_monsters.c"
#include "Loc_ai\LAi_location.c"
#include "Loc_ai\LAi_equip.c"
#include "Loc_ai\LAi_sounds.c"
#include "Loc_ai\LAi_CreateOfficer.c"


bool LAi_IsInitedAI = false;
bool LAi_IsCapturedLocation = false;
bool LAi_restoreStates = false;
bool LAi_IsBoarding = false;

// 
void LocAi_Init(ref loc)
{
	LAi_numloginedcharacters = 0;
	if(LAi_group_Init() == false) Trace("Error: Characters group logic not inited!!!");
	SetEventHandler("CharacterUpdate", "LAi_CharacterUpdate", 1);
	SetEventHandler("CharactersStateUpdate", "LAi_Character_FrameUpdate", 1);
	SetEventHandler("Location_CharacterEndTask", "LAi_CharacterEndTask", 0);
	SetEventHandler("Location_CharacterTaskFailure", "LAi_CharacterTaskFailure", 0);
	SetEventHandler("Location_CharacterBusyPos", "LAi_CharacterBusyPos", 0);
	SetEventHandler("Location_CharacterFollowGo", "LAi_CharacterFollowGo", 0);
	SetEventHandler("Location_CharacterFollowStay", "LAi_CharacterFollowStay", 0);
	SetEventHandler("Location_CharacterFightGo", "LAi_CharacterFightGo", 0);
	SetEventHandler("Location_CharacterFightStay", "LAi_CharacterFightStay", 0);
	SetEventHandler("Location_CharacterAttack", "LAi_CharacterAttack", 0);
	SetEventHandler("Location_CharacterBlock", "LAi_CharacterBlock", 0);
	SetEventHandler("Location_CharacterFire", "LAi_CharacterFire", 0);
	SetEventHandler("Location_CharacterIsFire", "LAi_CharacterIsFire", 0);
	SetEventHandler("Location_CharacterIsFight", "LAi_CharacterIsFight", 0);
	SetEventHandler("Location_CharacterEscapeSlide", "LAi_CharacterEscapeSlide", 0);
	SetEventHandler("Location_CharacterColThreshold", "LAi_CharacterColThreshold", 0);
	SetEventHandler("Location_Character_EndAction", "LAi_Character_EndAction", 0);
	LAi_IsInitedAI = true;
	LAi_IsCapturedLocation = IsLocationCaptured(loc.id);
	if(!actLoadFlag)
	{
		//  
		for(int i = 0; i < 32; i++)
		{
			DeleteAttribute(&Characters[LOC_FANTOM_CHARACTERS + i], "");
			Characters[LOC_FANTOM_CHARACTERS + i].index = LOC_FANTOM_CHARACTERS + i;
			Characters[LOC_FANTOM_CHARACTERS + i].id = "";
			Characters[LOC_FANTOM_CHARACTERS + i].location = "none";
			Characters[LOC_FANTOM_CHARACTERS + i].location.locator = "";
			Characters[LOC_FANTOM_CHARACTERS + i].location.group = "";
		}
	}
	//    
	bool isBoarding = false;
	if(CheckAttribute(loc, "boarding") == true)
	{
		if(loc.boarding == "true") isBoarding = true;
	}
	LAi_IsBoarding = isBoarding;
	if(!isBoarding)
	{
		int locIndex = 1;
		ref mainChr = GetMainCharacter();
		if(LAi_restoreStates)
		{
			LAi_SetCurHPMax(mainChr);
			LAi_UseAtidoteBottle(mainChr);
		}

		// SCREWFACE : crewmembers on shore mod
		if (LANDCREWMEMBERS)
		{

		if ((loc.type != "Shop") && (loc.type != "residence") && (loc.type != "house"))
		{
			ref crew = characterFromID("Treas_Crewmember_1");
			int con, maxcrew;
                        maxcrew = GetMaxLandCrew(mainChr.Ship.Crew.Quantity);
                        if(maxCrew > 0)
			{ 
				for(con =  1; con <= 10 ; con++)
				{
					crew = characterFromID("Treas_Crewmember_" + con);
					//if(WEAPONSLOCKER == 1) {GiveItemsBack(crew);}
					if(Lai_IsDead(crew))
					{
						RemoveCharacterCrew(mainChr,1);
						if(MAX_CREWMEMBERS>0){MAX_CREWMEMBERS = MAX_CREWMEMBERS-1;}
					}
					LAi_group_MoveCharacter(crew, LAI_GROUP_PLAYER);
					LAi_SetCitizenTypeNoGroup(crew);
					LAi_SetImmortal(crew, false);
					if((con<=maxcrew) && (con<=MAX_CREWMEMBERS) && !Lai_IsDead(crew))
					{
						crew.location = mainChr.location;
						if(CheckAttribute(loc, "locators.officers." + mainChr.location.locator + "_1"))
						{
							crew.location.group = "officers";
							crew.location.locator = mainChr.location.locator + "_" + locIndex;
						}
						else
						{
							//float x, y, z;
							//GetCharacterPos(&mainChr, &x, &y, &z);
							//string nearloc = LAi_FindNearestFreeLocator("reload", x, y, z);
							crew.location.group = mainChr.location.group;
							crew.location.locator = mainChr.location.locator; //nearloc;
						}
					}
					else
					{
						crew.location = "";
						crew.location.group = "";
						crew.location.locator = "";
					}
					crew.rank = mainChr.rank;
					crew.experience = mainChr.experience;
					crew.old.name = "Crewmember";
					crew.name = XI_ConvertString("Crewmember");
					crew.middlename = "";
					crew.lastname = "";
					crew.skill.Fencing = mainChr.skill.Fencing;
					if(IsCharacterPerkOn(mainChr,"BasicDefense")) {crew.perks.list.BasicDefense = true;}
					if(IsCharacterPerkOn(mainChr,"AdvancedDefense")) {crew.perks.list.AdvancedDefense = true;}					
					if(IsCharacterPerkOn(mainChr,"SwordplayProfessional")) {crew.perks.list.SwordplayProfessional = true;}	
					if(IsCharacterPerkOn(mainChr,"CriticalHit")) {crew.perks.list.CriticalHit = true;}
					if(IsCharacterPerkOn(mainChr,"Gunman")) {crew.perks.list.Gunman = true;}
					if(IsCharacterPerkOn(mainChr,"GunProfessional")) {crew.perks.list.GunProfessional = true;}
					LAi_SetHP(crew, mainChr.chr_ai.hp, mainChr.chr_ai.hp_max);
					LAi_SetOfficerType(crew);
					//if(WEAPONSLOCKER == 1) {EquipFromLocker(crew);}
				}
				//if(WEAPONSLOCKER == 1)
				//{
				//	for(con =  1; con <= 10 ; con++)
				//	{
				//		crew = characterFromID("Treas_Crewmember_" + con);
				//		GiveItemsBack(crew);
				//	}
				//}
			}
		}
		}
		// SCREWFACE : End

		for(i = 1; i < 4; i++)
		{
			int idx = GetOfficersIndex(mainChr, i);
			if(idx < 0) continue;

			if(locations[FindLocation(mainChr.location)].type=="jail") continue; // added by MAXIMUS

			DeleteAttribute(&Characters[idx], "location");
			Characters[idx].location = mainChr.location;
			Characters[idx].location.group = "officers";

// changed by MAXIMUS [bug with officers, not loaded into the next reload location] -->
			if(strcut(mainChr.location.locator, strlen(mainChr.location.locator)-4, strlen(mainChr.location.locator)-1)=="back") Characters[idx].location.locator = strcut(mainChr.location.locator, 0, strlen(mainChr.location.locator)-6) + "_" + locIndex;
			else Characters[idx].location.locator = mainChr.location.locator + "_" + locIndex;
			
			string ourChLocator = Characters[idx].location.locator;
			aref st; makearef(st, loc.locators.reload);
			int num = GetAttributesNum(st);
			for(int offic = 0; offic < num; offic++)
			{
				int at = GetAttributeN(st, offic);
				string sat = "locators.officers." + ourChLocator;
				int res = 0;
				if(!CheckAttribute(loc, sat))
				{
					Characters[idx].location.group = "reload";
					Characters[idx].location.locator = mainChr.location.locator;
				}
			}
// changed by MAXIMUS [bug with officers, not loaded into the next reload location] <--

			if(LAi_restoreStates)
			{
				LAi_SetCurHPMax(&Characters[idx]);
				LAi_UseAtidoteBottle(&Characters[idx]);
			}
			if(CheckAttribute(loc, "locators.officers"))
			{
				locIndex = locIndex + 1;
			}else{
				Characters[idx].location = "none";
				Characters[idx].location.group = "";
				Characters[idx].location.locator = "";
			}
		}
	}else{
		LAi_restoreStates = false;
	}
	LAi_IsCapturedLocation = IsLocationCaptured(loc.id);
}

// 
void LocAi_Release()
{
	for(int i = 0; i < LAi_numloginedcharacters; i++)
	{
		int idx = LAi_loginedcharacters[i];
		if(idx >= 0)
		{
			LAi_CharacterLogoff(&Characters[idx]);
		}
	}
	LAi_group_Release();
	LAi_IsInitedAI = false;
	LAi_numloginedcharacters = 0;
	DelEventHandler("CharacterUpdate", "LAi_CharacterUpdate");
	DelEventHandler("CharactersStateUpdate", "LAi_Character_FrameUpdate");
	DelEventHandler("Location_CharacterEndTask", "LAi_CharacterEndTask");
	DelEventHandler("Location_CharacterTaskFailure", "LAi_CharacterTaskFailure");
	DelEventHandler("Location_CharacterBusyPos", "LAi_CharacterBusyPos");
	DelEventHandler("Location_CharacterFollowGo", "LAi_CharacterFollowGo");
	DelEventHandler("Location_CharacterFollowStay", "LAi_CharacterFollowStay");
	DelEventHandler("Location_CharacterFightGo", "LAi_CharacterFightGo");
	DelEventHandler("Location_CharacterFightStay", "LAi_CharacterFightStay");
	DelEventHandler("Location_CharacterAttack", "LAi_CharacterAttack");
	DelEventHandler("Location_CharacterBlock", "LAi_CharacterBlock");
	DelEventHandler("Location_CharacterFire", "LAi_CharacterFire");
	DelEventHandler("Location_CharacterIsFire", "LAi_CharacterIsFire");
	DelEventHandler("Location_CharacterIsFight", "LAi_CharacterIsFight");
	DelEventHandler("Location_CharacterEscapeSlide", "LAi_CharacterEscapeSlide");
	DelEventHandler("Location_CharacterColThreshold", "LAi_CharacterColThreshold");
	DelEventHandler("Location_Character_EndAction", "LAi_Character_EndAction");	
	//  
	for(i = 0; i < 32; i++)
	{
		DeleteAttribute(&Characters[LOC_FANTOM_CHARACTERS + i], "");
		Characters[LOC_FANTOM_CHARACTERS + i].index = LOC_FANTOM_CHARACTERS + i;
		Characters[LOC_FANTOM_CHARACTERS + i].id = "";
		Characters[LOC_FANTOM_CHARACTERS + i].location = "none";
		Characters[LOC_FANTOM_CHARACTERS + i].location.locator = "";
		Characters[LOC_FANTOM_CHARACTERS + i].location.group = "";
	}
}


void LocAi_PostInit(ref loc)
{
	if(!LAi_IsBoarding) LAi_CharacterPostLogin(loc);
	if(ownDeckStarted() && !bMutinyDeckStarted) LAi_CharacterPostLogin(loc);//MAXIMUS: automatically fills ship by people
	for(int i = 0; i < LAi_numloginedcharacters; i++)
	{
		int idx = LAi_loginedcharacters[i];
		if(idx >= 0)
		{
			LAi_PostLoginInit(&Characters[idx]);
		}
	}
	LAi_restoreStates = false;
}

// 
void LAi_SaveInfo()
{
	LAi_group_SaveInfo();
}

//   
void LAi_NewGame()
{
	// 
	DeleteAttribute(&Lai_questdelays, "");
	//
	DeleteAttribute(&LAi_grp_relations, "");
	LAi_grp_playeralarm = 0;
	LAi_grp_alarmactive = false;
	//
	boarding_location = -1;
	boarding_location_type = -1;
	boarding_enemy_crew = 0;
	boarding_player_crew = 0;
	boarding_officers = 0;
	boarding_player_crew_per_chr = 1.0;
	boarding_exp = 0;
	LAi_boarding_process = false;
	//
	LAi_IsInitedAI = false;
	LAi_IsCapturedLocation = false;
	LAi_restoreStates = true;
	DeleteAttribute(&LAi_MonsterInfo, "");
	LAi_numloginedcharacters = 0;
	DeleteAttribute(&LAi_QuestFader, "");
	globalSGMode = false;
// KK -->
	bDeckStarted = false;
	bCabinStarted = false;
	bCrewStarted = false;
	bDeckEnter = false;
	bToDeckFromLand = false;
	DeckID = "";
	FromDeckIdx = -1;
	LandLocationIdx = -1;
	LandLocator = "";
// <-- KK
	//    
	LAi_SetPlayerType(GetMainCharacter());
}



